package simtools.wizard;




public class NetworkTopologyParameters {
	
	private String routersFile;
	private int defaultLinkSpeed;
	
	private int numberOfSurrogates;
	private int surrogateIncomingConnections;
	private int surrogateOutgoingConnections;
	private String placement;
	
	private int clientsOutgoingConnections;
	private int numberOfRetries;
	private int meanWaitingTimePerRetry;
	
	private int numberOfOriginServers;
	private int originServerIncomingConnections;
	
	public static NetworkTopologyParameters getInstance() {
		return NetworkTopologyParametersHolder.instance;
	}
	
	private static class NetworkTopologyParametersHolder {
        private static NetworkTopologyParameters instance = new NetworkTopologyParameters();
    }
	
	public void setNumberOfSurrogates(int numberOfSurrogates) {
		this.numberOfSurrogates = numberOfSurrogates;
	}

	public int getNumberOfSurrogates() {
		return numberOfSurrogates;
	}

	public void setSurrogateIncomingConnections(int surrogateIncomingConnections) {
		this.surrogateIncomingConnections = surrogateIncomingConnections;
	}

	public int getSurrogateIncomingConnections() {
		return surrogateIncomingConnections;
	}

	public void setSurrogateOutgoingConnections(int surrogateOutgoingConnections) {
		this.surrogateOutgoingConnections = surrogateOutgoingConnections;
	}

	public int getSurrogateOutgoingConnections() {
		return surrogateOutgoingConnections;
	}

	public void setPlacement(String placement) {
		this.placement = placement;
	}

	public String getPlacement() {
		return placement;
	}

	public void setClientsOutgoingConnections(int clientsOutgoingConnections) {
		this.clientsOutgoingConnections = clientsOutgoingConnections;
	}

	public int getClientsOutgoingConnections() {
		return clientsOutgoingConnections;
	}

	public void setNumberOfRetries(int numberOfRetries) {
		this.numberOfRetries = numberOfRetries;
	}

	public int getNumberOfRetries() {
		return numberOfRetries;
	}

	public void setMeanWaitingTimePerRetry(int meanWaitingTimePerRetry) {
		this.meanWaitingTimePerRetry = meanWaitingTimePerRetry;
	}

	public int getMeanWaitingTimePerRetry() {
		return meanWaitingTimePerRetry;
	}

	public void setNumberOfOriginServers(int numberOfOriginServers) {
		this.numberOfOriginServers = numberOfOriginServers;
	}

	public int getNumberOfOriginServers() {
		return numberOfOriginServers;
	}

	public void setOriginServerIncomingConnections(int originServerIncomingConnections) {
		this.originServerIncomingConnections = originServerIncomingConnections;
	}

	public int getOriginServerIncomingConnections() {
		return originServerIncomingConnections;
	}

	public void setRoutersFile(String routersFile) {
		this.routersFile = routersFile;
	}

	public String getRoutersFile() {
		return routersFile;
	}

	public void setDefaultLinkSpeed(int defaultLinkSpeed) {
		this.defaultLinkSpeed = defaultLinkSpeed;
	}

	public int getDefaultLinkSpeed() {
		return defaultLinkSpeed;
	}

}
