package simtools.xml;

import java.util.*;

import org.jdom.Document;
import org.jdom.Element;


public class Balance {
	private Document clients;
	private Document routers;
	Element newContent = new Element("Placements");

	@SuppressWarnings("unchecked")
	private Set<String> getClients() {
		Set<String> content = new HashSet<String>();
		Element root = clients.getRootElement();
		List<Element> contentList = root.getChildren("Request");
		Iterator<Element> i = contentList.iterator();

		while (i.hasNext()) {
			Element linksTemp = i.next();
			String id = linksTemp.getChild("Client").getText();
			content.add(id);
		}
		
		return content;

	}

	@SuppressWarnings("unchecked")
	private Set<String> getRouters() {
		Element root = routers.getRootElement();
		List<Element> nodes = root.getChildren("Link");
		Set<String> routers = new HashSet<String>();
		Iterator<Element> i = nodes.iterator();
		
		while (i.hasNext()) {
			Element nodesTemp = i.next();
			String nodeTo = nodesTemp.getChild("NodeTo").getText();
			String nodeFrom = nodesTemp.getChild("NodeFrom").getText();
			
			routers.add(nodeTo);
			routers.add(nodeFrom);
		}
		
		return routers;
	}

	public Document createTopology(Document client, Document routers) {
		this.clients = client;
		this.routers = routers;
		
		Set<String> setRouters = getRouters();
		Set<String> setClients = getClients();
	
		int clientsPerRouter = setClients.size() / setRouters.size();
		
		Iterator<String> clientIt = getClients().iterator();
		Iterator<String> routerIt = getRouters().iterator();
		
		//Parte inteira da diviso entre Clientes e Roteadores
		while (routerIt.hasNext()) {
			String idRouter = routerIt.next();
			for (int divisao = 0; divisao < clientsPerRouter; divisao++) {
				String idClient = clientIt.next();
				createXML(idClient, idRouter);
			}
		}
		
		//Resto da diviso entre Clientes e Roteadores
		routerIt = setRouters.iterator();
		while (clientIt.hasNext()) {
			String idClient = clientIt.next();
			String idRouter = routerIt.next();
			createXML(idClient, idRouter);	
		}
		
		return new Document(newContent);
	}
	
	private void createXML(String client, String router) {
		Element eChild = new Element("Placement"); 
		Element eClient;
		Element eRouter;
		
		eClient = new Element("Client");
		eClient.addContent(client);
		eRouter = new Element("Router");
		eRouter.addContent(router);

		eChild.addContent(eClient);
		eChild.addContent(eRouter);
		
		newContent.addContent(eChild);
	}
	
}
